/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 186 by dpavlin, Tue Mar 16 20:53:59 2010 UTC revision 226 by dpavlin, Tue Aug 10 17:03:15 2010 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    
44  lxc_status() {  lxc_status() {
45          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                  on_boot="       "                  boot="-"
47                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49          done                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
50                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51            done ) | column -t
52  }  }
53    
54    
# Line 53  cleanup_init_scripts() { Line 59  cleanup_init_scripts() {
59                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
60                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
61                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
62                    $rootfs/etc/rc?.d/*udev* \
63          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
64    
65            echo $1 > $rootfs/etc/hostname
66  }  }
67    
68    
# Line 73  setup_inittab() { Line 82  setup_inittab() {
82  }  }
83    
84    
85    lxc_log() {
86            echo `date +%Y-%m-%dT%H:%M:%S` $*
87    }
88    
89    
90  lxc_kill() {  lxc_kill() {
91          name=$1          name=$1
92          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 96  lxc_kill() {
96                  lxc-info -n $name                  lxc-info -n $name
97                  exit 1                  exit 1
98          fi          fi
99          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
100          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
101  }  }
102    
103  lxc_stop() {  lxc_stop() {
104            lxc_log "$name stop"
105          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
106          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
107            lxc_log "$name stoped"
108  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
109  }  }
110    
# Line 97  lxc_start() { Line 113  lxc_start() {
113          name=$1          name=$1
114    
115          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
116                  echo "$name start"                  lxc_log "$name start"
117                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
118                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
119                  lxc-info  -n $name                  lxc-info  -n $name
# Line 116  while true; do Line 132  while true; do
132          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq 1 ]; then
133    
134                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
135                  echo `date +%Y-%m-%dT%H:%M:%S` "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
136    
137                  case $runlevel in                  case $runlevel in
138                  N*)                  N*)
139                          # nothing for new boot state                          # nothing for new boot state
140                  ;;                  ;;
141                  ??0)                  ??0)
142                          echo "$name halt"                          lxc_log "$name halt"
143                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
144                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
145                          break                          break
146                  ;;                  ;;
147                  ??6)                  ??6)
148                          echo "$name reboot";                          lxc_log "$name reboot";
149                          lxc-stop -n ${name}                          lxc-stop -n ${name}
150                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
151                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 141  while true; do Line 157  while true; do
157                  ;;                  ;;
158                  esac                  esac
159          else          else
160                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks"
161          fi          fi
162    
163          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
164          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
165  done  done
166    
167  echo "${name} exited"  lxc_log "$name watchdog exited"
168    
169  }  }
170    
171    
172    usage() {
173            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
174            exit 3
175    }
176    
177  command_on_lxc() {  command_on_lxc() {
178  command=$1  command=$1
179  shift  shift
# Line 164  case "$command" in Line 185  case "$command" in
185  start)  start)
186          lxc_exists $1          lxc_exists $1
187          cleanup_init_scripts $1          cleanup_init_scripts $1
188          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
189          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
190            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
191          lxc_start $1          lxc_start $1
192          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
193          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 180  reload|force-reload|restart|reboot) Line 202  reload|force-reload|restart|reboot)
202  watchdog)  watchdog)
203          lxc_watchdog $1          lxc_watchdog $1
204          ;;          ;;
205    boot)
206            echo $1 > /var/lib/lxc/$1/on_boot
207            ;;
208    disable)
209            echo -n > /var/lib/lxc/$1/on_boot
210            ;;
211  *)  *)
212          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
213          ;;          ;;
214    
215  esac  esac
# Line 190  esac Line 217  esac
217  }  }
218    
219  command=$1  command=$1
220  shift  test -z "$command" && usage
   
221  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
222    shift
223    
224  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
225          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
226                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
227                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
228                            command_on_lxc $command $name
229                    else
230                            echo "# skip $command $name"
231                    fi
232          done          done
233  else  else
234          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.186  
changed lines
  Added in v.226

  ViewVC Help
Powered by ViewVC 1.1.26